/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package panel;

import database.StoreDB;
import java.awt.Color;
import java.awt.Font;
import java.text.SimpleDateFormat;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import resources.Guest;
import java.sql.*;
import Connection.ConnectionDB;
import PlugIn.MyInput;
import PlugIn.SubDefaultTableModel;
import java.awt.Cursor;
import java.text.DecimalFormat;
import javax.swing.JLabel;
import resources.Component;


/**
 *
 * @author CHINDA
 */
public class AddGuestDetail extends javax.swing.JPanel {

    /**
     * Creates new form AddGuestDetail
     */
    public AddGuestDetail() {
        initComponents();
        com = new Component();
        try{
            model = new SubDefaultTableModel(null,new Object[]{com.getRb().getString("lbGuestId"),com.getRb().getString("lbName"),
                com.getRb().getString("lbGender"),com.getRb().getString("lbVillage"),com.getRb().getString("lbOther")});
            modelDetail = new SubDefaultTableModel(null,new Object[]{com.getRb().getString("lbNo"),com.getRb().getString("lbGuestId"),
                com.getRb().getString("lbFamily"),com.getRb().getString("lbRiel"),com.getRb().getString("lbDollar"),
                com.getRb().getString("lbDong"),com.getRb().getString("lbDate"),});
            tblGuest.setModel(model);
            tblGuestDetail.setModel(modelDetail);
            tblGuest.setColumnWidth(0, 40);
            tblGuest.setColumnWidth(1, 90);
            tblGuest.setColumnWidth(2, 30);
            tblGuest.setColumnWidth(3, 70);
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
            date.setDate(sdf.parse(sdf.format(System.currentTimeMillis())));
            getDatabase("select id,name,gender,village,other from tblguest",model);
            detailId = getDatabase("select detailId,guestId,familyId,reil,dollar,dong,date from tbldetail",modelDetail);
            getNameDB();
            JLabel []lb ={lbNo,lbName,lbDate,lbDollar,lbDong,lbRiel,lbFamily,lbSearchName,lbSearchId};
            com.setLable(new String[]{"lbGuestId","lbName","lbDate","lbDollar","lbDong","lbRiel","lbFamily","lbSearchName","lbSearchId"}, lb);
            com.setButton(new String[]{"btnAdd","btnNew","btnDelete"}, btnAdd,btnNew,btnDelete);
            com.setPanel(new String[]{"panelAdd","panelInfor"}, panelAdd,panelInfor);
            lbGuestDetailTitle.setText(com.getRb().getString("lbGuestDetalTitle"));
            
            

        }catch(Exception e){
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lbGuestDetailTitle = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        panelAdd = new javax.swing.JPanel();
        lbNo = new javax.swing.JLabel();
        txtId = new javax.swing.JTextField();
        lbFamily = new javax.swing.JLabel();
        lbRiel = new javax.swing.JLabel();
        txtRiel = new javax.swing.JTextField();
        lbDollar = new javax.swing.JLabel();
        txtDollar = new javax.swing.JTextField();
        lbDong = new javax.swing.JLabel();
        txtDong = new javax.swing.JTextField();
        lbDate = new javax.swing.JLabel();
        btnNew = new javax.swing.JButton();
        btnAdd = new javax.swing.JButton();
        btnDelete = new javax.swing.JButton();
        lbName = new javax.swing.JLabel();
        txtName = new javax.swing.JTextField();
        lbSearchName = new javax.swing.JLabel();
        txtSearchName = new javax.swing.JTextField();
        date = new com.toedter.calendar.JDateChooser();
        jScrollPane2 = new javax.swing.JScrollPane();
        tblGuest = new PlugIn.SubJTable();
        cmb = new javax.swing.JComboBox<>();
        panelInfor = new javax.swing.JPanel();
        scTableDetail = new javax.swing.JScrollPane();
        tblGuestDetail = new PlugIn.SubJTable();
        lbSearchId = new javax.swing.JLabel();
        txtSearchId = new javax.swing.JTextField();

        setBackground(java.awt.Color.white);

        lbGuestDetailTitle.setFont(new java.awt.Font("Khmer OS Battambang", 1, 24)); // NOI18N
        lbGuestDetailTitle.setForeground(new java.awt.Color(204, 0, 0));
        lbGuestDetailTitle.setText("កត់ត្រាចំណងដៃ");

        jSeparator1.setBackground(new java.awt.Color(204, 0, 0));
        jSeparator1.setForeground(new java.awt.Color(0, 255, 0));

        panelAdd.setBackground(java.awt.Color.white);
        panelAdd.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "បន្ថែម", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Khmer OS Battambang", 1, 12))); // NOI18N
        panelAdd.setPreferredSize(new java.awt.Dimension(614, 284));

        lbNo.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbNo.setText("លេខសម្គាល់");

        txtId.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtId.setFocusable(false);

        lbFamily.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbFamily.setText("គ្រួសារ");

        lbRiel.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbRiel.setText("លុយរៀល");

        txtRiel.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtRiel.setText("0.00");
        txtRiel.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtRielFocusGained(evt);
            }
        });
        txtRiel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtRielKeyTyped(evt);
            }
        });

        lbDollar.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbDollar.setText("លុយដុល្លារ");

        txtDollar.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtDollar.setText("0.00");
        txtDollar.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtDollarFocusGained(evt);
            }
        });
        txtDollar.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtDollarKeyTyped(evt);
            }
        });

        lbDong.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbDong.setText("លុយដុង");

        txtDong.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtDong.setText("0.00");
        txtDong.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtDongFocusGained(evt);
            }
        });
        txtDong.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtDongKeyTyped(evt);
            }
        });

        lbDate.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbDate.setText("កាលបរិច្ឆេទ");

        btnNew.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        btnNew.setText("ថ្មី");
        btnNew.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnNew.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btnNewMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btnNewMouseExited(evt);
            }
        });
        btnNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNewActionPerformed(evt);
            }
        });

        btnAdd.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        btnAdd.setText("រក្សាទុក");
        btnAdd.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnAdd.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btnAddMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btnAddMouseExited(evt);
            }
        });
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddActionPerformed(evt);
            }
        });

        btnDelete.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        btnDelete.setText("លុប");
        btnDelete.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnDelete.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btnDeleteMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btnDeleteMouseExited(evt);
            }
        });
        btnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteActionPerformed(evt);
            }
        });

        lbName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbName.setText("ឈ្មោះភ្ញៀវ");

        txtName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N

        lbSearchName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbSearchName.setText("ស្វែងរកឈ្មោះ");

        txtSearchName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtSearchName.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                txtSearchNameCaretUpdate(evt);
            }
        });
        txtSearchName.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtSearchNameFocusGained(evt);
            }
        });

        date.setDateFormatString("yyyy/MM/dd");
        date.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N

        tblGuest.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tblGuest.setColorSelected(new java.awt.Color(51, 204, 255));
        tblGuest.setFont(new java.awt.Font("Khmer OS Battambang", 0, 12)); // NOI18N
        tblGuest.setRowHeight(30);
        tblGuest.getTableHeader().setResizingAllowed(false);
        tblGuest.getTableHeader().setReorderingAllowed(false);
        tblGuest.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblGuestMouseClicked(evt);
            }
        });
        tblGuest.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                tblGuestKeyPressed(evt);
            }
        });
        jScrollPane2.setViewportView(tblGuest);
        tblGuest.getTableHeader().setFont(new Font("Khmer OS Battambang",Font.BOLD,12));
        tblGuest.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

        cmb.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N

        javax.swing.GroupLayout panelAddLayout = new javax.swing.GroupLayout(panelAdd);
        panelAdd.setLayout(panelAddLayout);
        panelAddLayout.setHorizontalGroup(
            panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelAddLayout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addComponent(lbNo, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(34, 34, 34)
                        .addComponent(txtId, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(55, 55, 55)
                        .addComponent(lbName, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(25, 25, 25)
                        .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addComponent(lbFamily, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(34, 34, 34)
                        .addComponent(cmb, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(55, 55, 55)
                        .addComponent(lbRiel, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(25, 25, 25)
                        .addComponent(txtRiel, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addComponent(lbDong, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(34, 34, 34)
                        .addComponent(txtDong, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(55, 55, 55)
                        .addComponent(lbDollar, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(25, 25, 25)
                        .addComponent(txtDollar, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addComponent(lbDate, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(34, 34, 34)
                        .addComponent(date, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(55, 55, 55)
                        .addComponent(btnNew, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(25, 25, 25)
                        .addComponent(btnAdd, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnDelete, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addComponent(lbSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(34, 34, 34)
                        .addComponent(txtSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane2)))
        );
        panelAddLayout.setVerticalGroup(
            panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelAddLayout.createSequentialGroup()
                .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(lbNo))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(txtId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(9, 9, 9)
                        .addComponent(lbName))
                    .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(17, 17, 17)
                .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(lbFamily))
                    .addComponent(cmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lbRiel)
                    .addComponent(txtRiel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(20, 20, 20)
                .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(lbDong))
                    .addComponent(txtDong, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lbDollar)
                    .addComponent(txtDollar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(25, 25, 25)
                        .addComponent(lbDate))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(date, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addComponent(btnNew))
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnAdd)
                            .addComponent(btnDelete))))
                .addGap(23, 23, 23)
                .addGroup(panelAddLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelAddLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(lbSearchName))
                    .addComponent(txtSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
                .addContainerGap())
        );

        panelInfor.setBackground(java.awt.Color.white);
        panelInfor.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "ពត៍មាន", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Khmer OS Battambang", 1, 12))); // NOI18N

        tblGuestDetail.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tblGuestDetail.setColorSelected(new java.awt.Color(51, 204, 255));
        tblGuestDetail.setFont(new java.awt.Font("Khmer OS Battambang", 0, 12)); // NOI18N
        tblGuestDetail.setRowHeight(30);
        tblGuestDetail.getTableHeader().setResizingAllowed(false);
        tblGuestDetail.getTableHeader().setReorderingAllowed(false);
        tblGuestDetail.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblGuestDetailMouseClicked(evt);
            }
        });
        tblGuestDetail.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                tblGuestDetailKeyPressed(evt);
            }
        });
        scTableDetail.setViewportView(tblGuestDetail);
        tblGuestDetail.getTableHeader().setFont(new Font("Khmer OS Battambang",Font.BOLD,12));
        tblGuestDetail.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

        lbSearchId.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        lbSearchId.setText("ស្វែងរកលេខសម្គាល់");

        txtSearchId.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtSearchId.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                txtSearchIdCaretUpdate(evt);
            }
        });
        txtSearchId.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtSearchIdKeyTyped(evt);
            }
        });

        javax.swing.GroupLayout panelInforLayout = new javax.swing.GroupLayout(panelInfor);
        panelInfor.setLayout(panelInforLayout);
        panelInforLayout.setHorizontalGroup(
            panelInforLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelInforLayout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addGroup(panelInforLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelInforLayout.createSequentialGroup()
                        .addComponent(lbSearchId, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(txtSearchId, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(scTableDetail, javax.swing.GroupLayout.DEFAULT_SIZE, 436, Short.MAX_VALUE))
                .addGap(6, 6, 6))
        );
        panelInforLayout.setVerticalGroup(
            panelInforLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelInforLayout.createSequentialGroup()
                .addGap(3, 3, 3)
                .addGroup(panelInforLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelInforLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(lbSearchId))
                    .addComponent(txtSearchId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(11, 11, 11)
                .addComponent(scTableDetail, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                .addGap(6, 6, 6))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(panelAdd, javax.swing.GroupLayout.PREFERRED_SIZE, 648, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(panelInfor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(lbGuestDetailTitle, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)))
                .addGap(16, 16, 16))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lbGuestDetailTitle)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(panelInfor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(panelAdd, javax.swing.GroupLayout.DEFAULT_SIZE, 508, Short.MAX_VALUE))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnNewMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnNewMouseEntered
        btnNew.setBackground(Color.PINK);
        btnNew.setForeground(Color.BLACK);

    }//GEN-LAST:event_btnNewMouseEntered

    private void btnNewMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnNewMouseExited
        btnNew.setBackground(Color.white);
        btnNew.setForeground(Color.BLACK);
    }//GEN-LAST:event_btnNewMouseExited

    private void btnNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNewActionPerformed
        clear();
             
    }//GEN-LAST:event_btnNewActionPerformed

    private void btnAddMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddMouseEntered
        if(!btnAdd.getText().equals(com.getRb().getString("btnUpdate"))){
            btnAdd.setBackground(Color.PINK);
            btnAdd.setForeground(Color.BLACK);
        }else{
            btnAdd.setBackground(Color.green);
            btnAdd.setForeground(Color.black);
        }

        //[255,0,22]   11
    }//GEN-LAST:event_btnAddMouseEntered

    private void btnAddMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddMouseExited
        if(!btnAdd.getText().equals(com.getRb().getString("btnUpdate"))){
            btnAdd.setBackground(Color.white);
            btnAdd.setForeground(Color.BLACK);
        }else{
            btnAdd.setBackground(Color.red);
            btnAdd.setForeground(Color.black);
        }
    }//GEN-LAST:event_btnAddMouseExited
    
    private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddActionPerformed
        String btn = btnAdd.getText();
        try{
            if(checkTextField(txtId)){
                int id =Integer.parseInt(txtId.getText());
                int fid = getId("select id from tblfamily where `name` ='"+cmb.getSelectedItem().toString()+"'");
                double riel = Double.parseDouble(txtRiel.getText());
                double dollar = Double.parseDouble(txtDollar.getText());
                double dong = Double.parseDouble(txtDong.getText());
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                String d = sdf.format(date.getDate());
                String sql="";
                Object obj[] ={detailId+1,id,fid,riel,dollar,dong,d};
                if(!btn.equals(com.getRb().getString("btnUpdate"))){
                    int index = tblGuestDetail.getSelectedRow();
                    sql = "insert into tbldetail(guestId,familyId,reil,dollar,dong,date) values("
                                + id+","+fid+","+riel+","+dollar+","+dong+",'"+d+"')";
                    setDatabase(sql);
                    modelDetail.addRow(obj);
                    detailId++;
                    JOptionPane.showMessageDialog(this, com.getRb().getString("msgSave"));
                    int max = scTableDetail.getVerticalScrollBar().getMaximum();
                    scTableDetail.getVerticalScrollBar().setValue(max);
                    if(index<model.getRowCount()-1){
                        tblGuestDetail.getSelectionModel().setSelectionInterval(index+1, index+1);
                        txtId.setText(model.getValueAt(index+1, 0)+"");
                        txtName.setText(model.getValueAt(index+1, 1)+"");
                    }
                }else{
                    int click = JOptionPane.showConfirmDialog(this, com.getRb().getString("updateInfor"), com.getRb().getString("btnUpdate"), JOptionPane.YES_NO_OPTION);
                    if(click ==JOptionPane.YES_OPTION){
                        int index =tblGuestDetail.getSelectedRow();
                        int detailId = Integer.parseInt(tblGuestDetail.getValueAt(index, 0)+"");
                        obj[0] = detailId;
                        sql = "update tbldetail set guestId = "+id+",familyId = "+fid+",reil = "+riel
                                    +",dollar = "+dollar+",dong = "+dong+",date = '"+d+"' where detailId = "+detailId;
                        setDatabase(sql);
                        for(int i=0; i<obj.length;i++)
                            modelDetail.setValueAt(obj[i], index, i);
                        JOptionPane.showMessageDialog(this, com.getRb().getString("msgUpdate"));

                    }
                    
                }
            }
        }catch(Exception e){
              String msg;
              if(btn.equals(com.getRb().getString("btnUpdate")))
                  msg = com.getRb().getString("update");
              else
                  msg = com.getRb().getString("insert");
              JOptionPane.showMessageDialog(this, ConnectionDB.getUserName()+" "+msg,"Error",JOptionPane.ERROR_MESSAGE);
         }
        btnNewActionPerformed(evt);
        
    }//GEN-LAST:event_btnAddActionPerformed

    private void btnDeleteMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnDeleteMouseEntered
        btnDelete.setBackground(Color.PINK);
        btnDelete.setForeground(Color.BLACK);
    }//GEN-LAST:event_btnDeleteMouseEntered

    private void btnDeleteMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnDeleteMouseExited
        btnDelete.setBackground(Color.white);
        btnDelete.setForeground(Color.BLACK);
    }//GEN-LAST:event_btnDeleteMouseExited

    private void btnDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteActionPerformed
       try{
            if(!tblGuestDetail.getSelectionModel().isSelectionEmpty()){
                int index[] = tblGuestDetail.getSelectedRows();
                int id[] = new int[index.length];
                int count =0;
                String message="";
                for(int i=0; i<index.length;i++){
                    id[i] = Integer.parseInt(tblGuestDetail.getValueAt(index[i], 0)+"");
                    count++;
                }
                if(count==1)
                   message = "Are you sure you want to delete a record?";
                else
                   message = "Are you sure you want to delete "+count+" records?";
                int click = JOptionPane.showConfirmDialog(this, message, "Comfirm delete", JOptionPane.YES_NO_OPTION);
                String sql = "";
                if(click == JOptionPane.YES_OPTION){
                    for(int i=0; i<id.length; i++){
                        sql = "delete from tbldetail where detailId = "+id[i];
                        setDatabase(sql);
                    }
                    modelDetail.removeSelectedValues(tblGuestDetail);
                }
            }
       }catch(Exception e){
           JOptionPane.showMessageDialog(this, ConnectionDB.getUserName()+" "+com.getRb().getString("delete"),"Error",JOptionPane.ERROR_MESSAGE);
        }
        btnNewActionPerformed(evt);
    }//GEN-LAST:event_btnDeleteActionPerformed

    private void txtSearchNameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_txtSearchNameCaretUpdate
        String sql = "";
        if(!txtSearchName.getText().equals(""))
            sql = "select id,name,gender,village,other from tblguest where name like '"+txtSearchName.getText()+"%'";
        else
            sql = "select id,name,gender,village,other from tblguest";
        getDatabase(sql, model);
    }//GEN-LAST:event_txtSearchNameCaretUpdate

    private void txtDongFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtDongFocusGained
        txtDong.selectAll();
    }//GEN-LAST:event_txtDongFocusGained

    private void txtRielFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtRielFocusGained
        txtRiel.selectAll();
    }//GEN-LAST:event_txtRielFocusGained

    private void txtDollarFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtDollarFocusGained
        txtDollar.selectAll();
    }//GEN-LAST:event_txtDollarFocusGained

    private void txtSearchNameFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtSearchNameFocusGained
        tblGuestDetail.clearSelection();
    }//GEN-LAST:event_txtSearchNameFocusGained

    private void tblGuestDetailKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tblGuestDetailKeyPressed
        int index = tblGuestDetail.getSelectedRow();
        if(evt.getKeyCode() == 40)
            index++;
        else if (evt.getKeyCode()==38)
            index --;
        selectionRow(index);
    }//GEN-LAST:event_tblGuestDetailKeyPressed

    private void tblGuestKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tblGuestKeyPressed
        int index  = tblGuest.getSelectedRow();
        if(index<model.getRowCount()-1){
            if(evt.getKeyCode()==40)
                index++;
            else if(evt.getKeyCode() ==38)
                index--;
            txtId.setText(model.getValueAt(index, 0)+"");
            txtName.setText(model.getValueAt(index, 1)+"");
        }
    }//GEN-LAST:event_tblGuestKeyPressed

    private void tblGuestMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblGuestMouseClicked
        int index = tblGuest.getSelectedRow();
        clear();
        txtId.setText(tblGuest.getValueAt(index, 0)+"");
        txtName.setText(tblGuest.getValueAt(index, 1)+"");
       
    }//GEN-LAST:event_tblGuestMouseClicked

    private void tblGuestDetailMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblGuestDetailMouseClicked
        int index = tblGuestDetail.getSelectedRow();
        selectionRow(index);
        btnAdd.setText(com.getRb().getString("btnUpdate"));
        btnAdd.setBackground(Color.red);
        btnAdd.setForeground(Color.white);
    }//GEN-LAST:event_tblGuestDetailMouseClicked

    private void txtSearchIdCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_txtSearchIdCaretUpdate
        String sql;
        if(!txtSearchId.getText().equals("")){
           int id = Integer.parseInt(txtSearchId.getText());
           sql = "select * from tbldetail where guestId = "+id;
        }else{
            sql = "select * from tbldetail";
            //clear();
        }
        getDatabase(sql,modelDetail);
            
    }//GEN-LAST:event_txtSearchIdCaretUpdate

    private void txtSearchIdKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtSearchIdKeyTyped
        MyInput.inputInteger(evt);
    }//GEN-LAST:event_txtSearchIdKeyTyped

    private void txtRielKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtRielKeyTyped
        MyInput.inputFloat(evt, txtRiel);
    }//GEN-LAST:event_txtRielKeyTyped

    private void txtDongKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtDongKeyTyped
        MyInput.inputFloat(evt, txtDong);
    }//GEN-LAST:event_txtDongKeyTyped

    private void txtDollarKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtDollarKeyTyped
        MyInput.inputFloat(evt, txtDollar);
    }//GEN-LAST:event_txtDollarKeyTyped

    private void selectionRow(int index){
        try {
           DecimalFormat df = new DecimalFormat("#,##0.00");
           int id = Integer.parseInt(tblGuestDetail.getValueAt(index, 1)+"");
           txtId.setText(id+"");
           getNameDB(Integer.parseInt(tblGuestDetail.getValueAt(index, 2).toString()));
           txtRiel.setText(df.parse(tblGuestDetail.getValueAt(index, 3)+"")+"");
           txtDollar.setText(df.parse(tblGuestDetail.getValueAt(index, 4)+"")+"");
           txtDong.setText(df.parse(tblGuestDetail.getValueAt(index, 5)+"")+"");
           SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
           java.util.Date d = sdf.parse(tblGuestDetail.getValueAt(index, 6)+"");
           date.setDate(d);
           String sql = "select name from tblguest where id = "+id;
           Statement s = ConnectionDB.getDataCon().createStatement(1004,1008);
           ResultSet rs = s.executeQuery(sql);
           if(rs.first())
               txtName.setText(rs.getString(1));
           rs.close();
           s.close();
        } catch (Exception e) {
        }
    }
    private boolean checkTextField(JTextField ...txt){
        for(JTextField temp:txt){
            String str = temp.getText();
            if(str.equals("")){
                temp.requestFocus();
                return false;
            }
        }
        return true;
    }
    private void clearTextField(JTextField ...txt){
        for(JTextField temp: txt)
            temp.setText("0.00");
        txt[0].requestFocus();
    }
    private void setDatabase(String sql) throws Exception{
        Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
        s.execute(sql);
        s.close();
    }
    private int getDatabase(String sql,SubDefaultTableModel model){
        int id = 0;
        try {
            Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet r = s.executeQuery(sql);
            ResultSetMetaData rm = r.getMetaData();
            //String header[] = new String[rm.getColumnCount()];
            String row[] = new String[rm.getColumnCount()];
//            for(int i=0; i<header.length; i++)
//                header[i] = rm.getColumnName(i+1);
            model.removeAllRows();
            if(r.first())
                do{
                    detailId = r.getInt(1);
                    for(int i=0; i<row.length; i++)
                        row[i] = r.getString(i+1);
                    model.addRow(row);
                }while(r.next());
                r.close();
                s.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
        return id;
    }
    private void getNameDB(){
        try {
            Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet rs = s.executeQuery("select name from tblfamily where partnerId is null");
            while(rs.next())
                cmb.addItem(rs.getString(1));
            rs.close();
            s.close();
        } catch (Exception e) {
        }
    }
    private void getNameDB(int id){
        try {
            Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet rs = s.executeQuery("Select name from tblfamily where id = "+id);
            String name="";
            if(rs.first())
                name = rs.getString(1);
            for(int i=0; i<cmb.getItemCount(); i++)
                if(name.equals(cmb.getItemAt(i))){
                    cmb.setSelectedIndex(i);
                    break;
                }
            rs.close();
            s.close();
        } catch (Exception e) {
        }
    }
    private int getId(String sql){
        int id = 0;
        try {
            Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet rs = s.executeQuery(sql);
            if(rs.first())
                id = rs.getInt(1);
            rs.close();
            s.close();
        } catch (Exception e) {
        }
        return id;
    }
    private void clear(){
        try{
            clearTextField(txtRiel,txtDong,txtDollar);
            txtId.setText("");
            txtName.setText("");
            btnAdd.setText(com.getRb().getString("btnAdd"));
            btnAdd.setBackground(new Color(214,217,223));
            btnAdd.setForeground(new Color(0,0,0));
            tblGuestDetail.clearSelection();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
            date.setDate(sdf.parse(sdf.format(System.currentTimeMillis())));
        }catch(Exception e){
            
        }
    }
    Component com;
    private int detailId;
    private SubDefaultTableModel model,modelDetail;
    private StoreDB<Guest> guestDB,guestDetail;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnDelete;
    private javax.swing.JButton btnNew;
    private javax.swing.JComboBox<String> cmb;
    private com.toedter.calendar.JDateChooser date;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel lbDate;
    private javax.swing.JLabel lbDollar;
    private javax.swing.JLabel lbDong;
    private javax.swing.JLabel lbFamily;
    private javax.swing.JLabel lbGuestDetailTitle;
    private javax.swing.JLabel lbName;
    private javax.swing.JLabel lbNo;
    private javax.swing.JLabel lbRiel;
    private javax.swing.JLabel lbSearchId;
    private javax.swing.JLabel lbSearchName;
    private javax.swing.JPanel panelAdd;
    private javax.swing.JPanel panelInfor;
    private javax.swing.JScrollPane scTableDetail;
    private PlugIn.SubJTable tblGuest;
    private PlugIn.SubJTable tblGuestDetail;
    private javax.swing.JTextField txtDollar;
    private javax.swing.JTextField txtDong;
    private javax.swing.JTextField txtId;
    private javax.swing.JTextField txtName;
    private javax.swing.JTextField txtRiel;
    private javax.swing.JTextField txtSearchId;
    private javax.swing.JTextField txtSearchName;
    // End of variables declaration//GEN-END:variables
}
